/*
theremino serihal.ini 
  COMport COM7
  speed  57600
  slot read -
  slot write 1,2
  trasmit slot to serial OFF
  only on demand OFF
  limit value OFF
---
master V5
  pin 1, 2 as servo_16 -> pan&tilt
  maxvalue  1000
  tempo max 2000
  tempo min 1000
----
processing
  invia sulla seriale la posizione X,Y del mouse all'interno del quadrato
*/

import processing.serial.*;
Serial myPort; 

void setup(){
  size(200, 200);                             // disegna un quadrato 200x200
  printArray(Serial.list());                  // stampa la lista seriali disponibili
  String portName = Serial.list()[1];         // <-- aggiornare in base alla stampa
  myPort = new Serial(this, portName, 57600); // configura la porta seriale
}
//--------
void draw() {
  background(100);       // colora il quadrato di grigio
   int X=(mouseX)*5;    // normalizza a 1000
   int Y=(mouseY)*5;
   formatta1(Y);        // formatta e scrive Y
   myPort.write(59);    // scrive il separatore <;>
   formatta1(X);        // formatta e scrive X
   myPort.write(10);    // scrive il terminatore <LF>
   delay(100);
}
//--------


void formatta1(int a){
int appo=a;
byte[] cifra=new byte [10];
int n=int(log(a)/log(10))+1;      // calcola il numero di cifre
for (int i = 1; i <= n; i = i+1){
  cifra[i]=byte(appo%10);
  appo=appo/10;
  }
for (int i = n; i > 0; i = i-1){
  myPort.write(char(cifra[i]+48));  // converte cifra in ascii
  }

 }
//----------------